#version 120

// bump.vert

attribute vec3 tangent;

varying vec3 light;
varying vec3 view;

void main()
{
  // _ʒuCxNg
  vec4 position = gl_ModelViewMatrix * gl_Vertex;
  vec3 l = normalize((gl_LightSource[0].position * position.w - gl_LightSource[0].position.w * position).xyz);

  // @xNgƐڐxNgڋԂւ̕ϊs
  vec3 n = normalize(gl_NormalMatrix * gl_Normal);
  vec3 t = normalize(gl_NormalMatrix * tangent);
  vec3 b = cross(n, t);

  vec3 temp;

  // ڋԂɂxNg
  temp.x = dot(l, t);
  temp.y = dot(l, b);
  temp.z = dot(l, n);
  light = normalize(temp);

  // ڋԂɂ鎋xNg
  temp.x = dot(position.xyz, t);
  temp.y = dot(position.xyz, b);
  temp.z = dot(position.xyz, n);
  view = -normalize(temp);

  // eNX`WC_ʒu
  gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
  gl_Position = ftransform();
}
